local t = Def.ActorFrame{};
local BestGrade = STATSMAN:GetBestGrade();

-- static elements
t[#t+1] = Def.ActorFrame{
	-- background
	--LoadActor("back")..{ InitCommand=cmd(Center;setsize,SCREEN_WIDTH,SCREEN_HEIGHT); };


	Def.ActorFrame{
		InitCommand=cmd(Center);
		
		
		LoadActor(THEME:GetPathB("","fire-bg"))..{
			InitCommand=cmd(x,0;y,0;rate,1.5;zoomx,1.1,zoomy,1.5);
		};
	};
	
	LoadActor("swoosh_sound")..{
		OnCommand=cmd(play);
	};
	
	LoadActor(THEME:GetPathG("","_particles"),{
		NumParticles=6,
		ZoomMin = 30,
		ZoomMax = 50,
		VelocityXMin = -50,
		VelocityXMax = 50,
		VelocityYMin = -120,
		VelocityYMax = -70,
		SpinZ = 16,
	});
	
	LoadActor(THEME:GetPathG("","_particles"),{
		NumParticles=5,
		ZoomMin = 30,
		ZoomMax = 70,
		VelocityXMin = -70,
		VelocityXMax = 70,
		VelocityYMin = -160,
		VelocityYMax = -80,
		SpinZ = -32,
	});

	LoadActor(THEME:GetPathG("","_particles"),{
		NumParticles=6,
		ZoomMin = 20,
		ZoomMax = 60,
		VelocityXMin = -40,
		VelocityXMax = 40,
		VelocityYMin = -120,
		VelocityYMax = -60,
		SpinZ = -24,
	});
	
	LoadActor(THEME:GetPathG("","_particles"),{
		NumParticles=5,
		ZoomMin = 40,
		ZoomMax = 100,
		VelocityXMin = -60,
		VelocityXMax = 60,
		VelocityYMin = -120,
		VelocityYMax = -60,
		SpinZ = 24,
	});
	
	LoadActor(THEME:GetPathG("","_particles"),{
		NumParticles=6,
		ZoomMin = 50,
		ZoomMax = 70,
		VelocityXMin = -30,
		VelocityXMax = 30,
		VelocityYMin = -150,
		VelocityYMax = -100,
		SpinZ = -16,
	});
	

	LoadActor(THEME:GetPathB("","ring"))..{
		InitCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;spin;effectmagnitude,0,0,-20)
	};


	};

-- grade conditional bgs
local gradeBG;

if BestGrade <= 2 then
	-- color
	local possibleFiles = { "full1", "full2", "full3", "full4" };
	local bgFile;
	local _ = math.mod(Minute(),10);
	if _ < 2 then bgFile = possibleFiles[1];
	elseif _ < 5 then bgFile = possibleFiles[2];
	elseif _ < 7 then bgFile = possibleFiles[3];
	elseif _ < 11 then bgFile = possibleFiles[4];
	end;

	gradeBG = Def.ActorFrame{
		LoadActor(bgFile)..{
			InitCommand=cmd(Center;diffusealpha,0;);
			OnCommand=cmd(linear,0.2;diffusealpha,1);
		};
	};
	-- omes and ex
	local stage = GAMESTATE:GetCurrentStage();
	if stage == 'Stage_Final' then
		gradeBG[#gradeBG+1] = LoadActor("exbg")..{ InitCommand=cmd(Center); };
	elseif stage == 'Stage_Extra1' then
		gradeBG[#gradeBG+1] = LoadActor("omesbg")..{ InitCommand=cmd(Center); };
	end;
elseif BestGrade == 3 then
	-- mono
	local possibleFiles = { "chibi1", "chibi2", "chibi3", "chibi4" };
	local bgFile;
	local _ = math.mod(Minute(),3);
	if _ < 2 then bgFile = possibleFiles[1];
	elseif _ == 2 then bgFile = possibleFiles[2];
	end;
	gradeBG = Def.ActorFrame{
		LoadActor(bgFile)..{
			InitCommand=cmd(Center;diffusealpha,0;);
			OnCommand=cmd(linear,0.2;diffusealpha,1);
		};
	};
else
	-- april fools
	if MonthOfYear() == 4 and DayOfMonth() == 1 then
		gradeBG = Def.ActorFrame{
			LoadActor("unic")..{
				InitCommand=cmd(Center;diffusealpha,0;);
				OnCommand=cmd(linear,0.2;diffusealpha,1);
			};
		};
	else
		gradeBG = Def.ActorFrame{};
	end;
end;

t[#t+1] = gradeBG;

return t;