local t = LoadFallbackB();

t[#t+1] = StandardDecorationFromFile("StageDisplay", "StageDisplay");
t[#t+1] = StandardDecorationFromFile("LifeFrame", "LifeFrame");
t[#t+1] = StandardDecorationFromFile("StageFrame", "StageFrame");
t[#t+1] = StandardDecorationFromFile("ScoreFrame", "ScoreFrame");
t[#t+1] = StandardDecorationFromFile("TimeDisplay","TimeDisplay");

-- todo: move player life meters into their own file
-- sizes:
-- 268x20 = full
-- 212x20 = normal
-- 56x20 = 80%+

local normalZone = 212
local redZone = 56 -- speed rave (todo: have this work with passtype)

-- player 1

if GAMESTATE:IsPlayerEnabled(PLAYER_1) then
t[#t+1] = Def.ActorFrame{
	InitCommand=cmd(x,(SCREEN_CENTER_X-162);y,SCREEN_TOP+33;draworder,5);
	LoadActor("b4mIX")..{
		Name="Swipe";
		InitCommand=cmd(halign,0;x,-132;zoomto,0,20;texcoordvelocity,-1,0);
		LifeChangedMessageCommand=function(self,param)
			if param.Player == PLAYER_1 then
				local life = param.LifeMeter:GetLife();
				self:zoomto((life * (normalZone+redZone))-3,20);
			end;
		end;
	};
	Def.Quad{
		Name="BlueLife";
		InitCommand=cmd(halign,0;x,-133;zoomto,0,20;diffuse,color("#009BFFAA");diffuserightedge,color("#009BFFDD"));
		LifeChangedMessageCommand=function(self,param)
			if param.Player == PLAYER_1 then
				local life = param.LifeMeter:GetLife();
				if life >= 0.80 then life = 1;
				else life = scale(life,0,0.8,0,1);
				end;
				self:zoomx(life * normalZone);
			end;
		end;
	};
	-- todo: have this change based on passmark
	Def.Quad{
		Name="RedLife";
		InitCommand=cmd(halign,0;x,79;zoomto,0,21;diffuse,color("#FF0000DD");diffuserightedge,color("#FF0000EE"));
		LifeChangedMessageCommand=function(self,param)
			if param.Player == PLAYER_1 then
				local life = param.LifeMeter:GetLife();
				if life <= 0.80 then life = 0;
				else life = scale(life,0.8,1.0,0,1);
				end;
				self:zoomx(life * redZone);
			end;
		end;
	};
};
end;

-- player 2

if GAMESTATE:IsPlayerEnabled(PLAYER_2) then
t[#t+1] = Def.ActorFrame{
	InitCommand=cmd(x,(SCREEN_CENTER_X+162);y,SCREEN_TOP+33;draworder,5);
	LoadActor("b4mIX")..{
		Name="Swipe";
		InitCommand=cmd(halign,1;x,132;zoomto,0,20;texcoordvelocity,1,0);
		LifeChangedMessageCommand=function(self,param)
			if param.Player == PLAYER_2 then
				local life = param.LifeMeter:GetLife();
				self:zoomto((life * (normalZone+redZone))-3,20);
			end;
		end;
	};
	Def.Quad{
		Name="BlueLife";
		InitCommand=cmd(halign,1;x,133;zoomto,0,20;diffuse,color("#009BFFDD");diffuserightedge,color("#009BFFAA"));
		LifeChangedMessageCommand=function(self,param)
			if param.Player == PLAYER_2 then
				local life = param.LifeMeter:GetLife();
				if life >= 0.80 then life = 1;
				else life = scale(life,0,0.8,0,1);
				end;
				self:zoomx(life * normalZone);
			end;
		end;
	};
	Def.Quad{
		Name="RedLife";
		InitCommand=cmd(halign,1;x,-79;zoomto,0,21;diffuse,color("#FF0000EE");diffuserightedge,color("#FF0000DD"));
		LifeChangedMessageCommand=function(self,param)
			if param.Player == PLAYER_2 then
				local life = param.LifeMeter:GetLife();
				if life <= 0.80 then life = 0;
				else life = scale(life,0.8,1.0,0,1);
				end;
				self:zoomx(life * redZone);
			end;
		end;
	};
};
end;


--[[ dumb crap to get machine score working
if not GAMESTATE:IsCourseMode() then
	t[#t+1] = Def.Actor{
		Name="JudgmentController";
		JudgmentMessageCommand = function(self, params)
			Scoring[GetUserPref("UserPrefScoringMode")](params, STATSMAN:GetCurStageStats():GetPlayerStageStats(params.Player))
		end;
	};
end;
--]]

return t;